//
// Base styles
//

.card {
  position: relative;
  display: flex;
  flex-direction: column;
  min-width: 0; // See https://github.com/twbs/bootstrap/pull/22740#issuecomment-305868106
  height: $card-height;
  margin-bottom: $card-margin-bottom;
  word-wrap: break-word;
  background-clip: border-box;
  border: $card-border-width solid;
  @include border-radius($card-border-radius);
  @include themes($card-theme-map, $create: parent) {
    background-color: themes-get-value("card-bg");
    border-color: themes-get-value("card-border-color");
  }

  > hr {
    margin-right: 0;
    margin-left: 0;
  }

  > .list-group {
    border-top: inherit;
    border-bottom: inherit;

    &:first-child {
      border-top-width: 0;
      @include border-top-radius($card-inner-border-radius);
    }

    &:last-child  {
      border-bottom-width: 0;
      @include border-bottom-radius($card-inner-border-radius);
    }
  }

  &.drag,
  .drag {
    cursor: move;
  }
}

// Cards with color accent
.card[class^="bg-"],
.card[class*=" bg-"] {
  border-color: rgba(0, 0, 0, .125); //darken($value, 12.5%);
  .card-header {
    background-color: rgba(0, 0, 0, .05); //darken($value, 3%);
    border-color: rgba(0, 0, 0, .125); //darken($value, 12.5%);
  }
}

.card-body {
  // Enable `flex-grow: 1` for decks and groups so that card blocks take up
  // as much space as possible, ensuring footers are aligned to the bottom.
  flex: 1 1 auto;
  // Workaround for the image size bug in IE
  // See: https://github.com/twbs/bootstrap/pull/28855
  min-height: 1px;
  padding: $card-spacer-x;
  @include themes($card-theme-map, $create: parent) {
    color: themes-get-value("card-color");
  }
}

.card-title {
    font-weight: 700;
  margin-bottom: 0;
}

.card-subtitle {
    font-weight: 300;
    color: $primary-600;
  margin-top: -$card-spacer-y / 2;
  margin-bottom: 0;
}

.card-text:last-child {
  margin-bottom: 0;
}

.card-link {
  @include hover() {
    text-decoration: none;
  }

  + .card-link {
    @include ltr {
      margin-left: $card-spacer-x;
    }
    @include rtl {
      margin-right: $card-spacer-x;
    }
  }
}

//
// Optional textual caps
//

.card-header {
  padding: $card-spacer-y $card-spacer-x;
  margin-bottom: 0; // Removes the default margin-bottom of <hN>
  border-bottom: $card-border-width solid;
  @include themes($card-theme-map, $create: parent) {
    color: themes-get-value("card-cap-color");
    background-color: themes-get-value("card-cap-bg");
    border-color: themes-get-value("card-border-color");
  }

  &:first-child {
    @include border-radius($card-inner-border-radius $card-inner-border-radius 0 0);
  }

  + .list-group {
    .list-group-item:first-child {
      border-top: 0;
    }
  }
  .c-chart-wrapper {
    position: absolute;
    top: 0;
    right: 0;
    width: 100%;
    height: 100%;
  }
}

.card-footer {
  padding: $card-spacer-y $card-spacer-x;
  border-top: $card-border-width solid;
  @include themes($card-theme-map, $create: parent) {
    color: themes-get-value("card-cap-color");
    background-color: themes-get-value("card-cap-bg");
    border-color: themes-get-value("card-border-color");
  }

  &:last-child {
    @include border-radius(0 0 $card-inner-border-radius $card-inner-border-radius);
  }
}


//
// Header navs
//

.card-header-tabs {
  margin-right: -$card-spacer-x / 2;
  margin-bottom: -$card-spacer-y;
  margin-left: -$card-spacer-x / 2;
  border-bottom: 0;
}

.card-header-pills {
  margin-right: -$card-spacer-x / 2;
  margin-left: -$card-spacer-x / 2;
}

// Card image
.card-img-overlay {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  padding: $card-img-overlay-padding;
}

.card-img,
.card-img-top,
.card-img-bottom {
  flex-shrink: 0; // For IE: https://github.com/twbs/bootstrap/issues/29396
  width: 100%; // Required because we use flexbox and this inherently applies align-self: stretch
}

.card-img,
.card-img-top {
  @include border-top-radius($card-inner-border-radius);
}

.card-img,
.card-img-bottom {
  @include border-bottom-radius($card-inner-border-radius);
}


// Card deck

.card-deck {
  .card {
    margin-bottom: $card-deck-margin;
  }

  @include media-breakpoint-up(sm) {
    display: flex;
    flex-flow: row wrap;
    margin-right: -$card-deck-margin;
    margin-left: -$card-deck-margin;

    .card {
      // Flexbugs #4: https://github.com/philipwalton/flexbugs#flexbug-4
      flex: 1 0 0%;
      margin-right: $card-deck-margin;
      margin-bottom: 0; // Override the default
      margin-left: $card-deck-margin;
    }
  }
}


//
// Card groups
//

.card-group {
  // The child selector allows nested `.card` within `.card-group`
  // to display properly.
  > .card {
    margin-bottom: $card-group-margin;
  }

  @include media-breakpoint-up(sm) {
    display: flex;
    flex-flow: row wrap;
    // The child selector allows nested `.card` within `.card-group`
    // to display properly.
    > .card {
      // Flexbugs #4: https://github.com/philipwalton/flexbugs#flexbug-4
      flex: 1 0 0%;
      margin-bottom: 0;

      + .card {
        @include ltr {
          margin-left: 0;
          border-left: 0;
        }
        @include rtl {
          margin-right: 0;
          border-right: 0;
        }
      }

      // Handle rounded corners
      @if $enable-rounded {
        &:not(:last-child) {
          @include border-right-radius(0);

          .card-img-top,
          .card-header {
            // stylelint-disable-next-line property-blacklist
            border-top-right-radius: 0;
          }
          .card-img-bottom,
          .card-footer {
            // stylelint-disable-next-line property-blacklist
            border-bottom-right-radius: 0;
          }
        }

        &:not(:first-child) {
          @include border-left-radius(0);

          .card-img-top,
          .card-header {
            // stylelint-disable-next-line property-blacklist
            border-top-left-radius: 0;
          }
          .card-img-bottom,
          .card-footer {
            // stylelint-disable-next-line property-blacklist
            border-bottom-left-radius: 0;
          }
        }
      }
    }
  }
}


//
// Columns
//

.card-columns {
  .card {
    margin-bottom: $card-columns-margin;
  }

  @include media-breakpoint-up(sm) {
    column-count: $card-columns-count;
    column-gap: $card-columns-gap;
    orphans: 1;
    widows: 1;

    .card {
      display: inline-block; // Don't let them vertically span multiple columns
      width: 100%; // Don't let their width change
    }
  }
}


//
// Accordion
//

.accordion {
  > .card {
    overflow: hidden;

    &:not(:last-of-type) {
      border-bottom: 0;
      @include border-bottom-radius(0);
    }

    &:not(:first-of-type) {
      @include border-top-radius(0);
    }

    > .card-header {
      @include border-radius(0);
      margin-bottom: -$card-border-width;
    }
  }
}

.card-placeholder {
  background: rgba($black, .025);
  border: 1px dashed $gray-300;
}

.card-header-icon-bg {
  display: inline-block;
  width: ($card-spacer-y * 2) + ($font-size-base * $line-height-base);
  padding: $card-spacer-y 0;
  margin: (- $card-spacer-y) $card-spacer-x (- $card-spacer-y) (- $card-spacer-x);
  line-height: inherit;
  color: $card-icon-color;
  text-align: center;
  background: $card-icon-bg;
  border-right: $card-border-width solid;
  @include themes($card-theme-map, $create: parent) {
    border-right: themes-get-value("card-border-color");
  }
}

.card-header-actions {
  display: inline-block;

  @include ltr {
    float: right;
    margin-right: - ($spacer / 4);
  }
  @include rtl {
    float: left;
    margin-left: - ($spacer / 4);
  }
}

.card-header-action {
  padding: 0 ($spacer / 4);
  color: $gray-600;

  &:hover {
    color: $body-color;
    text-decoration: none;
  }
}


// Cards with color accent
@include theme-variant() {
  .card-accent-#{$color} {
    @include card-accent-variant($value);
  }
}

.card-full {
  margin-top: - $spacer;
  margin-right: - $grid-gutter-width / 2;
  margin-left: - $grid-gutter-width / 2;
  border: 0;
  border-bottom: $card-border-width solid $border-color;
}

@include media-breakpoint-up(sm) {
  .card-columns {

    &.cols-2 {
      column-count: 2;
    }
  }
}
